#include <vector>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include "imprimir.h"

int main(int argc, char *argv[])
{
    std::srand(std::time(0));

    std::vector<int> v;
    for (int i = 0; i < 20; ++i)
        v.push_back(std::rand() % 10 + 1);
    
    // Antes de insertar las repeticiones vamos a reservar el espacio final
    // necesario. La razn es que la funcin insert va a aumentar el tamao
    // del vector y si ese tamao supera la capacidad es muy posible que
    // el vector deba ser reubicado en otra zona de memoria. Eso invalidara
    // todos los iteradores sobre el vector y dado que el bucle lo haremos
    // con un iterador, producira resultados indefinidos (violacin de 
    // segmento lo ms probable).
    // Al reservar la memoria de antemano sabemos que insert no invalidar
    // nunca los iteradores anteriores al punto de insercin ya que no nos
    // vamos a pasar de la capacidad fijada.
    size_t capacidad = 0;
    for (std::vector<int>::iterator i = v.begin(); i != v.end(); ++i)
        capacidad += *i;
    v.reserve(capacidad);

    for (std::vector<int>::iterator i = v.begin(); i != v.end();) {
        v.insert(i + 1, *i - 1, *i);
        i += *i;
    }

    std::cout << v << std::endl;
}
