#include <vector>
#include <iostream>
#include <cmath>

#include "imprimir.h"


void generarPrimos(int n, std::vector<int> &primos)
{
    // Si el vector de primos est vaco aadimos el nmero 2 por 
    // conveniencia, esto facilita el cdigo siguiente.
    if (primos.size() == 0)
        primos.push_back(2);
    
    for (int i = primos.back(); i <= n; ++i) {
        bool esPrimo = true;
        for (std::vector<int>::iterator p = primos.begin();
             p != primos.end() && esPrimo; ++p) {
            esPrimo = i % *p != 0;
        }
        if (esPrimo)
            primos.push_back(i);
    }
}

int main(int argc, char *argv[])
{
    std::vector<int> primos;
    
    while (!std::cin.eof()) {
        int n;
        std::cin >> n;
        if (!std::cin.fail()) {
            generarPrimos(n / 2, primos);
            bool primerDivisor = true;
            for (std::vector<int>::iterator p = primos.begin();
                 p != primos.end() && *p <= n; ++p) {
                int exponente = 0;
                int divisor = *p;
                while (n % divisor == 0) {
                    n /= divisor;
                    ++exponente;
                }
                if (exponente != 0) {
                    if (!primerDivisor)
                        std::cout << " * ";
                    primerDivisor = false;

                    std::cout << divisor;
                    if (exponente != 1) {
                        std::cout << '^' << exponente;
                    }
                }

            }
            std::cout << std::endl;
        }
    }
}
