#ifndef IMPRIMIR_H
#define IMPRIMIR_H

#include <iostream>

template <typename Contenedor, typename _CharT, typename _Traits>
inline std::basic_ostream<_CharT, _Traits>&
operator<<(std::basic_ostream<_CharT, _Traits> &out, const Contenedor &c)
{
    for (typename Contenedor::const_iterator i = c.begin(); i != c.end();) {
        out << *i;
        if (++i != c.end())
            out << ' ';
    }
    return out;
}

template <typename _CharT, typename _Traits>
inline std::basic_ostream<_CharT, _Traits>&
operator<<(std::basic_ostream<_CharT, _Traits> &out, const _CharT *c)
{
    for (; *c != '\0'; ++c)
        out << *c;
    return out;
}

template <typename _CharT, typename _Traits>
inline std::basic_ostream<_CharT, _Traits>&
operator<<(std::basic_ostream<_CharT, _Traits> &out, _CharT *c)
{
    for (; *c != '\0'; ++c)
        out << *c;
    return out;
}

#endif
